﻿//denis-gr, denisgrshn, 2007
//denis-gr@yandex.ru

#target photoshop

// заставить бы не перерисовывать экран
// функции exit() на самом деле в Фотошопе нет -- пусть Адобе стыдно будет!
app.bringToFront();
$.level = 0;
app.displayDialogs = DialogModes.NO; // при ALL -- загрузка выделения идет по-другому 

//--------------------------------------
var myTil=300;  //менять здесь
//--------------------------------------
var myTilThr=255-(255*myTil/400) + 2; //threshold // "+ 2" -- типа ошибки округления

with (app) {
	try {
	var myDoc=app.activeDocument;
		} catch (error) {
		alert ("Нет активного документа!"); 
		exit();
		} 
	if (myDoc.mode!=DocumentMode.CMYK) { 
		alert ("Документ должен быть CMYK!");
		exit();
	}


	// layers - слои и множества первого уровня 
	// artLayers - слои первого уровня
	// слои в множествах вообще за слой не считаются!
	// layerSets - множества только
	
	// если в палитре слоев нарисовано больше одного объекта - artLayers или layerSets
	if (myDoc.layers.length!=1) {
		if (confirm ("Документ содержит несколько слоев.\rCкрипт будет работать только с Background-слоем.\rПродолжить?") == false ) { exit(); }
	}

	try {
	var myLayer0=myDoc.backgroundLayer;
		} catch (error) { alert ("Не найден Background-слой."); exit(); }
	if (myLayer0.visible == false) {alert("Что-то Background-слой погашен :\)"); exit()};


	var myLayerVis = new Array();
	// запоминаем видимость всех слоев и гасим
	for (i=0; i < myDoc.layers.length-1; i++) { 
			// "-1" -- у бекграунда самый старший индекс (?) 
			// Если переделывать под activeLayer, то здесь придется учитывать!!
		if (myDoc.layers[i].isBackgroundLayer) {alert("Внутренняя ошибка скрипта!"); exit()}
		myLayerVis[i]=myDoc.layers[i].visible;
		myDoc.layers[i].visible=false;
	}

	

	myDoc.activeChannels=myDoc.componentChannels; // наверное надо
	myDoc.selection.deselect(); //!!! - иначе ужас!!!
	// if (myDoc.quickMaskMode) {}
	// ------ может еще на быструю маску и ещё на не-CMYK какалы проверить ??? --------- 


	// реализовано два метода обработки картинки
	var myMethod = "Curves" // гнем кривые
	//	var myMethod = "reSep" //передележка
	
	switch (myMethod) {
	case "Curves":    
 		for (i=1; i<=30; i++) {
			var myLayer1=myLayer0.duplicate();
			myLayer1.mixChannels( [ [25, 25, 25, 25, 0 ]  ],true);
			myLayer1.threshold(myTilThr);
			myDoc.selection.load (myDoc.channels["Black"]) 
			myDoc.selection.invert();
			// проверка на пустое выделение
			try {
			myDoc.selection.feather(1); 
			} 
			catch (error) { break; } 
			finally { 
			myDoc.activeLayer=myLayer0;
			myLayer1.remove();  
			};
			// 255 = 0%, 0 = 100%,     15=94%
			var myDelta;
			myDelta=5*2,55;  // 5% - спад кривых MY 
			myDoc.activeChannels=[  myDoc.channels["Cyan"]  ];
			myLayer0.adjustCurves( [ [0, myDelta*1.1], [255,255] ] ); // 1.1-1-1 -- баланс в тенях
			myDoc.activeChannels=[  myDoc.channels["Magenta"], myDoc.channels["Yellow"]  ];
			myLayer0.adjustCurves( [ [0, myDelta], [255,255] ] ); 

			myDoc.activeChannels=myDoc.componentChannels;
			myDoc.selection.deselect(); 
		}//i
	break; // "Curves"  
	case "reSep":
 		for (i=1; i<=1; i++) {  // нет возможности проверить пустое ли выделение (???)
			//alert (i);
			var myLayer1=myLayer0.duplicate();
			myLayer1.mixChannels( [ [25, 25, 25, 25, 0 ]  ],true);
			myLayer1.threshold(myTilThr);
			myDoc.selection.load (myDoc.channels["Black"]) 
			myDoc.selection.invert();
			// проверка на пустое выделение
			try {
			myDoc.selection.feather(1); 
			} 
			catch (error) { break; } 
			finally { 
			myDoc.activeLayer=myLayer0;
			myLayer1.remove();  
			};
			
			// if (i= 2) {alert ("Неудачно! Проверьте настройки цвета"); break; };
			myDoc.selection.copy();
			// здесь надо проверить/выставить установки цвета
			// при неправильных установках зацикливется
			var desc1 = new ActionDescriptor();
		    var desc2 = new ActionDescriptor();
			desc2.putString( stringIDToTypeID("preset"), "Clipboard" );
			desc2.putString( charIDToTypeID("Nm  "), "Temp_Document" );
			desc1.putObject( charIDToTypeID("Nw  "), charIDToTypeID("Dcmn"), desc2 );
			executeAction( charIDToTypeID("Mk  "), desc1, DialogModes.NO );

			var myDocTemp = activeDocument;
			myDocTemp.paste();
			myDocTemp.changeMode(ChangeMode.LAB);

			// ----------- RELATIVE COLORIMETRIC--???
			myDocTemp.changeMode(ChangeMode.CMYK);
			myDocTemp.selection.selectAll();
			myDocTemp.selection.copy();
			myDocTemp.close(SaveOptions.DONOTSAVECHANGES);
			
			activeDocument = myDoc; // на всякий случай, если открытых документов несколько
			myDoc.paste(); 
			myDoc.activeLayer.merge();
			myDoc.activeLayer=myLayer0; // наверно лишнее
			myDoc.activeChannels=myDoc.componentChannels;
			myDoc.selection.deselect(); 
		}//i	
	
	
	break; // "reSep"  
	} // switch

	// восстанавливаем видимость слоев
	for (i=0; i < myDoc.layers.length-1; i++) { 
			// "-1" -- у бекграунда самый старший индекс (?) 
			// Если переделывать под activeLayer, то здесь придется учитывать!!
		if (myDoc.layers[i].isBackgroundLayer) {alert("Внутренняя ошибка скрипта!"); exit()}
		myDoc.layers[i].visible=myLayerVis[i];
	}


} // app
